#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#ifndef WIN32
#include <unistd.h>
#include <sys/types.h>
#else
#include <Winsock2.h>
#endif
#include <assert.h>
#include <inVRs/Modules/Network/Network.h>

class Client
{
	OSG::StreamSocket* socket;
public:
	void send(NetMessage* msg)
	{
		unsigned msgSize = msg->getBufferSize();
		NetMessage* msgCopy = new NetMessage(msg);
		msgCopy->reset();
		msgCopy->putFirstUInt32(msgSize);
		socket->send(msgCopy->getBufferPointer(), msgSize + 4);
		delete msgCopy;
	}

	bool connect(const char* host, int port)
	{
		OSG::SocketAddress address;
		try 
		{
			address = OSG::SocketAddress(host, port);
		} 
		catch (...) 
		{
			printf("Client::connect: ERROR: couldn't find server %s!\n", host);
			return false;
		} 

		socket = new OSG::StreamSocket();
	
		try 
		{
			socket->open();
			printf("Client::connect(): trying to connect to server ...\n");
			socket->connect(address);
			printf("Client::connect(): connection established\n");
		} 
		catch (...) 
		{
			printf("Client::connect(): Error at connection attempt!\n");
			try 
			{
				socket->close();
			} catch (...) 
			{
			}
			return false;
		} 
		return true;
	}
};