#include "Client.h"
#include "DirectoryListener.h"

Client network;

void sendFile(const char* fileName)
{
	FILE* fio = NULL;
	fio = fopen(fileName,"rb");
	if(!fio) printf("File was not found\n");
	else
	{
		NetMessage message;
		fseek(fio,0,SEEK_END);
		size_t size = ftell(fio);
		fseek(fio,0,SEEK_SET);
		if(fread(message.allocateAtFront(size),1,size,fio)!=size) printf("File contains less data than expected\n");
		getc(fio);
		if(getc(fio)!=EOF) printf("File contains more data than expected\n");
		fclose(fio);
		message.putFirstUInt32(size);
		network.send(&message);
		printf("File sent\n");
	}
}

int main(int argc, char** argv)
{
	char* connection;
	if(argc==2) connection = argv[1];
	else connection = "127.0.0.1";
	if(network.connect(connection,8085))
	{
		printf("Press enter to exit\n");
		DirectoryListener dirListener(".");
		dirListener.addAddListener(&sendFile);
		dirListener.listen();
		getchar();
		dirListener.stop();
	}	
	else printf("Could not connect to server\n");
	return 0;
}